      PROGRAM Editor

******This is a simple editor created using keyboard and cursor 
******routines from the F77PC library.
******Last updated: 24 February 1989

******Main program

      INCLUDE 'EDITCOM'

      CALL InitScreen
      CALL InitColours
      CALL StartRoutine
      CALL MainLoop
      CALL EndRoutine
      CALL InitScreen
      END

******End of main program

      SUBROUTINE InitColours

******Initialises the colours according to adaptor present

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      IF ((Adaptor() .EQ. MonoAdap).OR.( Adaptor() .EQ. Hercules)) THEN
	  Colour1 = Black
	  Colour2 = Black
	  Colour3 = LightGrey
	  Colour4 = LightGrey
	  Colour5 = White
	  Colour6 = Black
      ELSE
	  Colour1 = Blue
	  Colour2 = Red
	  Colour3 = Red
	  Colour4 = Yellow
	  Colour5 = Yellow
	  Colour6 = White
      ENDIF
      END

******End of subroutine InitColours

      SUBROUTINE StartRoutine

******Reads in the file ( if there is one ) and displays the screen

      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine, TempBuffer ( 100 )
      INTEGER*1 APosition
      INTEGER*1 LineNo

      CALL CursorOff
      DemoUnit = 20
      TPosition = 0
      BPosition = 0
      APosition = 0
      Finish = .FALSE.
      LineNo = 1
      CALL ScreenInit
      CALL GetCom ( FileName )
      IF ( FileName ( 2:2 ) .EQ. ' ' ) THEN
	  OPEN ( 10, FILE = 'default.txt' )
      ELSE
	  OPEN ( 10, FILE = FileName )
10        Read ( 10, 20, ERR = 30, END = 30 ) TempLine
	  IF ( LineNo .GT. 24 ) THEN
	      TempBuffer ( APosition + 1 ) = TempLine
	      APosition = APosition + 1
	  ELSE
	      CALL LineOut ( TempLine, LineNo )
	      LineNo = LineNo + 1
	  ENDIF
	  GOTO 10
30        IF ( APosition .GT. 0 ) THEN
	      BotBuffer ( BPosition + 1 ) = TempBuffer ( APosition )
	      BPosition = BPosition + 1 
	      APosition = APosition - 1 
	      GOTO 30
	  ENDIF
      ENDIF
      CALL GoToXY ( 1, 1 )
      CALL CursorOn
20    FORMAT ( A80 )
      END

******End of subroutine StartRoutine

      SUBROUTINE ScreenInit 

******Sets up the display and writes the message line

      INCLUDE 'EDITCOM'

      CALL ScreenUnit ( DemoUnit )
      CALL Paper ( Colour2 )
      CALL Ink ( Colour5 )
      CALL ClrScr
      CALL GoToXY ( 1, 25 )
      Write ( DemoUnit, 1 )
      CALL GoToXY ( 10, 25 )
      CALL PutChattr ( 'I', Colour3, Colour6, 1 )
      CALL GoToXY ( 11, 25 )
      Write ( DemoUnit, 2 )
      CALL GoToXY ( 20, 25 )
      CALL PutChattr ( 'F', Colour3, Colour6, 1 )
      CALL GoToXY ( 21, 25 )
      Write ( DemoUnit, 3 )
      CALL GoToXY ( 30, 25 )
      CALL PutChattr ( 'D', Colour3, Colour6, 1 )
      CALL GoToXY ( 31, 25 )
      Write ( DemoUnit, 4 )
      CALL GoToXY ( 40, 25 )
      CALL PutChattr ( 'L', Colour3, Colour6, 1 )
      CALL GoToXY ( 41, 25 )
      Write ( DemoUnit, 5 )
      CALL GoToXY ( 55, 25 )
      CALL PutChattr ( 'R', Colour3, Colour6, 1 )
      CALL GoToXY ( 56, 25 )
      Write ( DemoUnit, 6 )
      CALL GoToXY ( 65, 25 )
      Write ( DemoUnit, 7 ) 
      CALL TextWindow ( 1, 1, 80, 24 )
      CALL Paper ( Colour1 )
      CALL Ink ( Colour4 )
      CALL ClrScr
1     FORMAT ( '&OPTIONS-' )
2     FORMAT ( '&nsert,' )
3     FORMAT ( '&inish,' )
4     FORMAT ( '&elete,' )
5     FORMAT ( '&ine insert,' )
6     FORMAT ( '&estore.' )
7     FORMAT ( '&<CR> ends ins.' )
      END

******End of subroutine ScreenInit

      SUBROUTINE LineOut ( ALine, ANumber )

******Writes ALine to display line number ANumber

      INCLUDE 'F77PC'

      CHARACTER*80 ALine
      INTEGER*1 ANumber, Count, YBefore
      
      YBefore = WhereY ( )
      DO 10 Count = 1, 80
	  CALL GoToXY ( Count, ANumber )
	  CALL PutChar ( ALine ( Count:Count ), 1 )
10    CALL GoToXY ( 1, YBefore )
      END

******End of subroutine LineOut


      SUBROUTINE LineIn ( ALine, ANumber )

******Reads ALine from display line number ANumber

      INCLUDE 'F77PC'

      CHARACTER*80 ALine
      INTEGER*1 ANumber, Count, YBefore
      
      YBefore = WhereY ( )
      DO 10 Count = 1, 80
	  CALL GoToXY ( Count, ANumber )
	  ALine ( Count:Count ) = CharXY ( )
10    CALL GoToXY ( 1, YBefore ) 
      END

******End of subroutine LineIn

      SUBROUTINE MainLoop

******Repeat until the end

      INCLUDE 'EDITCOM'

10    IF ( .NOT. Finish ) THEN
	  CALL WhatNext
	  GOTO 10
      ENDIF
      END

******End of subroutine MainLoop

      SUBROUTINE WhatNext 

******Wait for a key to be pressed and decide what type of key

      INCLUDE 'EDITCOM'

      INTEGER Scan
      CHARACTER*1 Ch

      CALL GetKeyboard ( Ch, Scan )
      IF ( Ch .EQ. Char ( 0 ) ) THEN
	  CALL EscapeSelect ( Scan )
      ELSE IF ( ( Ch .EQ. 'I' ) .OR. ( Ch .EQ. 'i' ) ) THEN
	  CALL DoInsert
      ELSE IF ( ( Ch .EQ. 'D' ) .OR. ( Ch .EQ. 'd' ) ) THEN
	  CALL DoDeleteLine
      ELSE IF ( ( Ch .EQ. 'L' ) .OR. ( Ch .EQ. 'l' ) ) THEN
	  CALL DoLineInsert
      ELSE IF ( ( Ch .EQ. 'R' ) .OR. ( Ch .EQ. 'r' ) ) THEN
	  CALL DoRestoreLine
      ELSE IF ( ( Ch .EQ. 'F' ) .OR. ( Ch .EQ. 'f' ) ) THEN
	  Finish = .TRUE.
      ENDIF
      END

******End of subroutine WhatNext

      SUBROUTINE EscapeSelect ( AScan )

******Key pressed was an escape character : decide which one

      INTEGER AScan

      IF ( AScan .EQ. 71 ) THEN
	  CALL GoToXY ( 1, 1 )
      ELSE IF ( AScan .EQ. 72 ) THEN
	  CALL MoveUp
      ELSE IF ( AScan .EQ. 75 ) THEN
	  CALL MoveLeft
      ELSE IF ( AScan .EQ. 77 ) THEN
	  CALL MoveRight
      ELSE IF ( AScan .EQ. 80 ) THEN
	  CALL MoveDown
      ENDIF
      END

******End of subroutine EscapeSelect

      SUBROUTINE DoInsert 

******Enter insert mode for current line

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine
      INTEGER*1 XBefore

      CALL CursorOff
      XBefore = 0 + WhereX ( )
      CALL LineIn ( TempLine, WhereY ( ) )
      CALL GoToXY ( 1, WhereY ( ) )
      CALL CursorOn
      CALL EditString ( TempLine, XBefore )
      IF ( WhereY ( ) .EQ. 24 ) THEN
	  CALL MoveDown
	  CALL GoToXY ( 1, WhereY ( ) )
      ELSE
	  CALL GoToXY ( 1, WhereY ( ) + 1 )
      ENDIF
      END

******End of subroutine DoInsert

      SUBROUTINE DoLineInsert

******Insert an extra line

      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine

      CALL CursorOff
      CALL LineIn ( TempLine, 24 )
      BotBuffer ( BPosition + 1 ) = TempLine
      BPosition = BPosition + 1
      CALL InsLine
      CALL CursorOn
      END

******End of subroutine DoLineInsert

      SUBROUTINE DoDeleteLine

******Delete current line and place in the line buffer

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine
      INTEGER*1 XBefore, YBefore

      CALL CursorOff
      XBefore = WhereX ( )
      YBefore = WhereY ( )
      CALL LineIn ( LineBuffer, YBefore )
      CALL DelLine
      IF ( BPosition .NE. 0 ) THEN
	  TempLine = BotBuffer ( BPosition ) 
	  CALL LineOut ( TempLine, 24 )
	  BPosition = BPosition - 1
      ENDIF
      CALL GoToXY ( XBefore, YBefore )
      CALL CursorOn
      END

******End of subroutine DoDeleteLine

      SUBROUTINE DoRestoreLine 

******Insert line from line buffer at current position

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine
      INTEGER*1 XBefore

      CALL CursorOff
      XBefore = WhereX ( )
      CALL LineIn ( TempLine, 24 )
      BotBuffer ( BPosition + 1 ) = TempLine
      BPosition = BPosition + 1
      TempLine = LineBuffer 
      CALL InsLine
      CALL LineOut ( TempLine, WhereY ( ) )
      CALL GoToXY ( XBefore, WhereY ( ) )
      CALL CursorOn
      END

******End of subroutine DoRestoreLine

      SUBROUTINE MoveLeft

******Move cursor left 

      INCLUDE 'F77PC'

      CALL GoToXY ( WhereX ( ) - 1, WhereY ( ) )
      END

******End of subroutine MoveLeft

      SUBROUTINE MoveRight

******Move cursor right

      INCLUDE 'F77PC'

      CALL GoToXY ( WhereX ( ) + 1, WhereY ( ) )
      END

******End of subroutine MoveRight

      SUBROUTINE MoveUp

******Move cursor up

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine
      INTEGER*1 XBefore

      IF ( WhereY ( ) .EQ. 1 ) THEN
	  IF ( TPosition .GT. 0 ) THEN
	      CALL CursorOff
	      XBefore = WhereX ( )
	      CALL LineIn ( TempLine, 24 )
	      BotBuffer ( BPosition + 1 ) = TempLine
	      BPosition = BPosition + 1
	      CALL ScrollDown ( 1 )
	      TempLine = TopBuffer ( TPosition )
	      TPosition = TPosition - 1
	      CALL LineOut ( TempLine, 1 )
	      CALL GoToXY ( XBefore, 1 )
	      CALL CursorOn
	  ENDIF
      ELSE
	  CALL GoToXY ( WhereX ( ), WhereY ( ) - 1 )
      ENDIF
      END

******End of subroutine MoveUp

      SUBROUTINE MoveDown

******Move cursor down

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine
      INTEGER*1 XBefore

      IF ( WhereY ( ) .EQ. 24 ) THEN
	  IF ( BPosition .GT. 0 ) THEN
	      CALL CursorOff
	      XBefore = WhereX ( )
	      CALL LineIn ( TempLine, 1 )
	      TopBuffer ( TPosition + 1 ) = TempLine
	      TPosition = TPosition + 1
	      CALL ScrollUp ( 1 )
	      TempLine = BotBuffer ( BPosition )
	      BPosition = BPosition - 1
	      CALL LineOut ( TempLine, 24 )
	      CALL GoToXY ( XBefore, 24 )
	      CALL CursorOn
	  ENDIF
      ELSE
	  CALL GoToXY ( WhereX ( ), WhereY ( ) + 1 )
      ENDIF
      END

******End of subroutine MoveDown

      SUBROUTINE EndRoutine 

******Write the edited file to FileName and clear the screen

      INCLUDE 'F77PC'
      INCLUDE 'EDITCOM'

      CHARACTER*80 TempLine
      INTEGER*1 Count
      
      CALL CursorOff
      Rewind ( 10 )
      DO 10 Count = 1, TPosition
	  Write ( 10, 40 ) TopBuffer ( Count )
10    CONTINUE
      DO 20 Count = 1, 24
	  CALL LineIn ( TempLine, Count )
	  Write ( 10, 40 ) TempLine
20    CONTINUE
      DO 30 Count = BPosition, 1, -1
	  Write ( 10, 40 ) BotBuffer ( Count )
30    CONTINUE
40    FORMAT ( A80 )
      END

******End of subroutine EndRoutine
******End of editor demonstration program.
