      PROGRAM GRAPHDEMO

******This program draws a series of rotated squares of increasing
******size, waits for a key to be pressed, and then clears the screen

******Last updated 24 February 1989

      INCLUDE 'F77PC'

      INTEGER*1 Adap
      CHARACTER*1 Answer

      CALL INITSCREEN
      Adap = ADAPTOR ( )
      IF ( ( Adap .EQ. 0 ) .OR. ( Adap .EQ. 1 ) ) THEN
	  Write ( *, 10 )
      ELSE IF ( Adap .EQ. 2 ) THEN
	  CALL CGADEM
      ELSE IF ( Adap .EQ. EGAdap) THEN
40        Write ( *, 20 )
	  Read ( *, 30 ) Answer
	  IF ( ( Answer .EQ. 'E' ) .OR. ( Answer .EQ. 'e' ) ) THEN
	      CALL EGADEM
	  ELSE IF ( ( Answer .EQ. 'C' ) .OR. ( Answer .EQ. 'c' ) ) THEN
	      CALL CGADEM
	  ELSE 
	      GOTO 40
	  ENDIF
      ELSE IF ( Adap .EQ. VGAdap) THEN
41        Write ( *, 21 )
	  Read ( *, 30 ) Answer
	  IF ( ( Answer .EQ. 'V' ) .OR. ( Answer .EQ. 'v' ) ) THEN
	      CALL VGADEM
	  ELSE IF ( ( Answer .EQ. 'E' ) .OR. ( Answer .EQ. 'e' ) ) THEN
	      CALL EGADEM
	  ELSE IF ( ( Answer .EQ. 'C' ) .OR. ( Answer .EQ. 'c' ) ) THEN
	      CALL CGADEM
	  ELSE 
	      GOTO 41
	  ENDIF
      ELSE IF ( Adap .EQ. Hercules) THEN
	  CALL HERCDEM
      ENDIF
50    IF ( .NOT. KEYPRESSED ( ) ) GOTO 50
      CALL INITSCREEN
10    FORMAT ( '+Graphics adaptor needed to run this program' )
20    FORMAT ( '+CGA (C) or EGA (E) demonstration ? - ' )
21    FORMAT ( '+CGA (C), EGA (E) or VGA(V) demonstration ? - ' )
30    FORMAT ( A1 )
      END

******End of main program unit

      SUBROUTINE CGADEM

******Performs the demonstration for Colour Graphics Adaptor

      INCLUDE 'F77PC'

      INTEGER*2 Size, XC, YC
      INTEGER*1 Pal, LstCol

      CALL SETSCREENMODE ( CGAGraph )
      XC = 160
      YC = 100
      LstCol = 3
      Pal = 0
      DO 60 Size = 10, 20
	  CALL CGAPALETTE ( Pal )
	  IF ( Pal .EQ. 0 ) THEN
	      Pal = 1
	  ELSE
	      Pal = 0
	  ENDIF
	  CALL SQRS ( Size * 4, 1.0, XC, YC, LstCol )
60    CONTINUE
      END

******End of subroutine CGADem

      SUBROUTINE EGADEM

******Performs the demonstration for Enhanced Graphics Adaptor

      INCLUDE 'F77PC'

      INTEGER*2 Size, XC, YC
      INTEGER*1 LstCol

      CALL SETSCREENMODE ( EGAGraph )
      XC = 320
      YC = 175
      LstCol = 15
      DO 70 Size = 10, 20
	  CALL SQRS ( Size * 4, 0.9, XC, YC, LstCol )
70    CONTINUE
      END

******End of subroutine EGADem

      SUBROUTINE VGADEM

******Performs the demonstration for Enhanced Graphics Adaptor

      INCLUDE 'F77PC'

      INTEGER*2 Size, XC, YC
      INTEGER*1 LstCol

      CALL SETSCREENMODE ( VCGraph )
      XC = 320
      YC = 240
      LstCol = 15
      DO 70 Size = 10, 20
	  CALL SQRS ( Size * 8, 1.2, XC, YC, LstCol )
70    CONTINUE
      END

******End of subroutine VGADem

      SUBROUTINE HercDEM

******Performs the demonstration for Hercules Graphics Adaptor

      INCLUDE 'F77PC'

      INTEGER*2 Size, XC, YC
      INTEGER*1 LstCol

      CALL SETSCREENMODE ( HercGraph )
      XC = 360
      YC = 174
      LstCol = 1
      DO 70 Size = 10, 20
	  CALL SQRS ( Size * 10, 0.85, XC, YC, LstCol )
70    CONTINUE
      END

******End of subroutine HercDem

      SUBROUTINE SQRS ( Size, Adj, XC, YC, LstCol )

******Draw the series of rotated squares with half-diagonal Size

      REAL PiBy20, Theta, Adj
      INTEGER*2 XC, YC, Size, XVar, YVar
      INTEGER*1 Colour, LstCol

      PARAMETER ( PiBy20 = 0.15702 )

      Theta = 0
80        CONTINUE
	  XVar = NINT ( Size * COS ( Theta ) )
	  YVar = NINT ( Size * SIN ( Theta ) )
	  CALL POINTS ( XVar, YVar, XC, YC, Colour, Adj )
	  Theta = Theta + PiBy20
	  IF ( Colour .EQ. LstCol ) THEN
	      Colour = 1
	  ELSE
	      Colour = Colour + 1
	  ENDIF
	  IF ( Theta .LE. 0.75 ) GOTO 80
      END

******End of subroutine Sqrs

      SUBROUTINE POINTS ( XV, YV, XC, YC, Colour, Adj )

******Draws a square with centre ( XC, YC ) and a vertex at ( XV, YV )
******( relative to the centre ), and another at ( -XV, YV ), using
******eight-way symmetry

      INTEGER*2 XV, YV, XC, YC, XA, YA
      INTEGER*1 Colour
      REAL      Adj

      XA = YV
      YA = NINT ( REAL(XV) * Adj)
      YV = NINT ( REAL(YV) * Adj)
      CALL DRAW ( XC+XV, YC+YV, XC+XA, YC-YA, Colour )
      CALL DRAW ( XC+XA, YC-YA, XC-XV, YC-YV, Colour )
      CALL DRAW ( XC-XV, YC-YV, XC-XA, YC+YA, Colour )
      CALL DRAW ( XC-XA, YC+YA, XC+XV, YC+YV, Colour )
      CALL DRAW ( XC-XV, YC+YV, XC+XA, YC+YA, Colour )
      CALL DRAW ( XC+XA, YC+YA, XC+XV, YC-YV, Colour )
      CALL DRAW ( XC+XV, YC-YV, XC-XA, YC-YA, Colour )
      CALL DRAW ( XC-XA, YC-YA, XC-XV, YC+YV, Colour )
      END

******End of subroutine Points
******End of FGraph display program
