      PROGRAM Pages

******Demonstration of the use of multiple pages in F77-PC
******27 November 1987

******Main program

      INCLUDE 'F77PC'

      CALL InitScreen
      IF ((Adaptor() .LT. CGAdap ).OR.(Adaptor() .EQ. Hercules)) THEN
	  Write ( *, 10 )
      ELSE
	  CALL DoDemo
      ENDIF
10    FORMAT ( '&This demonstration requires a CGA, EGA or VGA' )
      END

******End of main program

      SUBROUTINE DoDemo

******This is the core of the demonstration. The adaptor has been
******checked to have at least four text pages

      INCLUDE 'F77PC'

      INTEGER Count

      CALL ScreenUnit ( 10 )
      Write ( 10, 10 )
      CALL DrawOtherPages ( 10, Blue, White )
      Write ( 10, 20 )
      CALL DrawOtherPages ( 20, Red, Yellow )
      Write ( 10, 30 )
      CALL DrawOtherPages ( 30, Green, Cyan )
      Write ( 10, 40 )
      CALL Await ( 300 )
      DO 1 Count = 20, 1, -1
	  CALL Await ( Count )
	  CALL DisplayPage ( 1 )
	  CALL Await ( Count )
	  CALL DisplayPage ( 2 )
	  CALL Await ( Count )
	  CALL DisplayPage ( 3 )
1     CONTINUE
      Write ( 10, 50 )
      CALL Await ( 500 )
      CALL DisplayPage ( 0 )
      CALL Await ( 500 )
      CALL InitScreen
10    FORMAT ( '&You are watching page 0.'/' '/
     +         ' While this message is being generated,' )
20    FORMAT ( ' quite different output is being built up' )
30    FORMAT ( ' in pages 1, 2 and 3. In a short time the' )
40    FORMAT ( ' display will be changed to show this output' )
50    FORMAT ( ' '/' Now back to page 0 again.' )
      END

******End of subroutine DoDemo

      SUBROUTINE DrawOtherPages ( XStart, Paper, Ink )

******Draws a series of large '1's on pages 1, 2 and 3

      INTEGER XStart, Paper, Ink

      CALL UpdatePage ( 1 )
      CALL Draw1 ( XStart, Paper, Ink )
      CALL UpdatePage ( 2 )
      CALL Draw1 ( XStart+5, Paper, Ink )
      CALL UpdatePage ( 3 )
      CALL Draw1 ( XStart+10, Paper, Ink )
      CALL UpdatePage ( 0 )
      END

******End of subroutine DrawOtherPages

      SUBROUTINE Draw1 ( X, Paper, Ink )

******Generates an image of the digit '1' at position defined by X

      INTEGER X, Row, Paper, Ink, TopRow, BottomRow

      PARAMETER ( TopRow = 5, BottomRow = 15 )

      DO 1 Row = TopRow, BottomRow-2
	  CALL GoToXY ( X, Row )
	  CALL PutChattr ( '1', Paper, Ink, 3 )
1     CONTINUE
      CALL GoToXY ( X-1, TopRow+1 )
      CALL PutChattr ( '1', Paper, Ink, 1 )
      CALL GoToXY ( X-2, TopRow+2 )
      CALL PutChattr ( '1', Paper, Ink, 2 )
      CALL GoToXY ( X-1, BottomRow-1 )
      CALL PutChattr ( '1', Paper, Ink, 5 )
      CALL GoToXY ( X-1, BottomRow )
      CALL PutChattr ( '1', Paper, Ink, 5 )
      END

******End of subroutine Draw1

      SUBROUTINE Await ( n )

******Use the AwaitRetrace subroutine as a delay, as well as to
******synchronise with the screen refresh

      INTEGER n, lc

      DO 10 lc = 1, n
	  CALL AwaitRetrace
10    CONTINUE
      END

******End of subroutine Await
******End of Pages demonstration program.
