      BLOCK DATA _ERRDATA
C     Last updated 21 Nov 1991.
      INCLUDE 'ERRORS.FOR'
      COMMON /_ERRCLASS/ ERRCLASS
      CHARACTER*24 ERRCLASS(13)
      DATA (ERRCLASS(I),I=ERRINTRAN,ERRUSER) /
     1  'INTEGER RANGE',
     2  'INTEGER DOMAIN',
     3  'FLOATING POINT RANGE',
     4  'FLOATING POINT DOMAIN',
     5  'CHARACTER VARIABLE',
     6  'CONSISTENCY',
     7  'BOUNDS',
     8  'HEAP',
     9  'I/O CONVERSION OR FORMAT',
     T  'FILE PROGRAMMING',
     1  'OPERATING SYSTEM FILE',
     2  'MISCELLANEOUS',
     3  'USER DEFINED' /
      END
      SUBROUTINE _HERR
      INTEGER unit_star,unit_internal
      PARAMETER (unit_star=-2,unit_internal=-3)
      INCLUDE 'ERRORS.FOR'
      INTEGER*4 I,SAVE,ERRNO,VALIDERRORS,UNIT_NO
      CHARACTER NAMEUSED*255
      COMMON /_ERRCLASS/ ERRCLASS
      CHARACTER*24 ERRCLASS(13)
      COMMON /_PFLAG/ PF
      INTEGER*1 PF
      LOGICAL*4 CON,AFFIRM

C     Save the current error mask and prevent follow through errors
      SAVE=IMASK()
      CALL SETMASK(ERRDEFAULT)
C     Find those error classes that are unmasked
      VALIDERRORS=ISTICKY().AND.(.NOT.SAVE)
C     Store OS error number as prone to corruption
      ERRNO=IOSERR()
C     Write "errors have occurred" message to error handle
      CALL _NLERR
      CALL _NLERR
      CALL _PRINTERR('Runtime Error(s) detected --')
C     Write new line to error handle
      CALL _NLERR

C     Check each error class to see if it has occurred
      DO 10 I=ERRINTRAN,ERRMISC
	IF (BTEST(VALIDERRORS,I)) THEN
	  CALL _PRINTERR('Class ')
	  CALL _PRINTI(I)     !Write an integer to the error handle
	  CALL _PRINTERR(' -- ')
C         Print the error class using a slightly different
C         routine that does not print trailing spaces.
	  CALL _PRINTERR2(ERRCLASS(I))
	  CALL _PRINTERR(' ERROR')
C         The most recent error also has subclass information
	  IF (I.EQ.ICLASS()) THEN
	      CALL _PRINTERR(' subclass ')
	      CALL _PRINTI(ISUBCLASS())
	  ENDIF
	  CALL _NLERR
	  IF (I.EQ.ERROS) THEN ! Even more info. available for OS errors
	    IF (ERRNO .GT. 0) THEN
	      CALL _PRINTERR('  OS error code: ')
	      CALL _PRINTI(ERRNO)
	      CALL _NLERR
	    ENDIF
	  ENDIF
C         For file-related errors return filename if one existed
	  IF (I.EQ.ERRIO .OR. I.EQ.ERRFILE .OR. I.EQ.ERROS) THEN
	    UNIT_NO = IUnitErr()
	    CALL _PRINTERR('  Unit: ')
	    IF (UNIT_NO .GE. 0) THEN
	      CALL _PRINTI(UNIT_NO)
	    ELSEIF (UNIT_NO .EQ. unit_star) THEN
	      CALL _PRINTERR('*')
	    ELSEIF (UNIT_NO .EQ. unit_internal) THEN
	      CALL _PRINTERR('internal')
	    ELSE
	      CALL _PRINTERR('N/A')
	    ENDIF
	    CALL ERRFILENAME(NAMEUSED)
	    IF (NAMEUSED.NE.' ') THEN
	      CALL _PRINTERR('  File: ')
	      CALL _PRINTERR2(NAMEUSED)
	    ENDIF
	    CALL _NLERR
	  ENDIF
	ENDIF
10    CONTINUE

C     Now call the routine to print out addresses and line numbers
      CALL _DPRSTC
C     Stop if stack overflow on procedure entry occurred.
      IF ((ICLASS() .EQ. ERRMISC) .AND. (ISUBCLASS() .EQ. 0)) THEN
	CON=.FALSE.
      ELSE
C     Now see if running in batch mode. If not then ask the user if he
C     wishes to continue; in the case of continuing the error locations
C     are reset.
	IF (BTEST(PF,0)) THEN
	  CON=.FALSE.
	ELSE
	  CON=AFFIRM('Do you wish to continue')
	ENDIF
      ENDIF
      IF (CON) THEN
	CALL SETSTICKY(0)
	CALL CLEARERROR
	CALL SETMASK(SAVE)
      ELSE
	CALL EXITPG(ICLASS())
      ENDIF
      END
