      PROGRAM TextDemo

******This program demonstrates the text facilities in the F77-PC
******library
******25 November 1987

******Main program unit

      INCLUDE 'F77PC'
      INCLUDE 'TEXTCOM'
      
      DemoUnit = 10
      CALL InitScreen
      CALL DoInitialisation
      CALL ScreenUnit ( DemoUnit ) 
      CALL DemoFirstScreen
      CALL DemoSecondScreen
      CALL DemoThirdScreen
      CALL DemoCursor 
      CALL DemoWindows
      CALL InitScreen
      END

******End of main program unit

      SUBROUTINE Wait ( Delay )

******Halts the program for 'delay' seconds

      INTEGER Delay
      INTEGER*4 Hours, Mins, Secs, Hundreths, InitialSecs,
     +          NewSecs

      CALL Time ( Hours, Mins, Secs, Hundreths )
      InitialSecs = Hours*60 + Mins*60 + Secs
10    CONTINUE
      CALL Time ( Hours, Mins, Secs, Hundreths )
      NewSecs = Hours*60 + Mins*60 + Secs
      IF ( ( InitialSecs + Delay ) .GT. NewSecs ) GOTO 10
      END

******End of subroutine Wait

      SUBROUTINE WaitForKey

******Waits for a key to be pressed and removes it from the buffer

      LOGICAL*1 KeyPressed
      INTEGER*2 Scan
      CHARACTER*1 Ch

10    IF ( .NOT. KeyPressed ( ) ) GOTO 10
      CALL GetKeyboard ( Ch, Scan )
      END

******End of subroutine WaitForKey

      SUBROUTINE InitAWindow ( X1, Y1, X2, Y2, Double )

******This subroutine creates a window using TextWindow, clears it
******and draws a border using TextFrame.

      INTEGER X1, Y1, X2, Y2
      LOGICAL Double

      CALL TextWindow ( X1-1, Y1-1, X2+1, Y2+1 ) 
      CALL ClrScr
      CALL TextFrame ( Double )
      END

******End of subroutine InitAWindow

      SUBROUTINE DoInitialisation

******Sets up attributes for output according to adaptor present

      INCLUDE 'F77PC'
      INCLUDE 'TEXTCOM'

      INTEGER TempAdap

      TempAdap = Adaptor ( ) 
      IF ((Adaptor() .EQ. MonoAdap ).OR.(Adaptor() .EQ. Hercules)) THEN
	  CALL SetScreenMode ( MonoText )
	  MaxCursor = 13
	  NormalPaper = Black 
	  NormalInk   = LightGrey 
	  AttrPaper1 = Black
	  AttrPaper2 = LightGrey
	  AttrPaper3 = Black
	  AttrInk1   = White
	  AttrInk2   = Black
	  AttrInk3   = Blue
	  WindowPaper1 = Black
	  WindowPaper2 = Black
	  WindowInk1   = White
	  WindowInk2   = White
	  Screen5      = Black
      ELSE
	  CALL SetScreenMode ( C80Text )
	  MaxCursor = 6
	  NormalPaper = Black 
	  NormalInk   = White 
	  AttrPaper1 = Red
	  AttrPaper2 = Blue
	  AttrPaper3 = LightGrey
	  AttrInk1   = White
	  AttrInk2   = Yellow
	  AttrInk3   = Yellow
	  WindowPaper1 = Red
	  WindowPaper2 = Blue
	  WindowInk1   = Yellow
	  WindowInk2   = Yellow
	  Screen5      = LightBlue
      ENDIF
      END

******End of subroutine DoInitialisation

      SUBROUTINE DemoFirstScreen

******Shows how text can be written to the whole screen and how PutChar
******and PutChattr work.

      INCLUDE 'F77PC'
      INCLUDE 'TEXTCOM'

      CALL Paper ( NormalPaper )
      CALL Ink ( NormalInk )
      CALL ClrScr
      Write ( DemoUnit, 10 )
      CALL GoToXY ( 1, 4 )
      Write ( DemoUnit, 20 )
      CALL Wait ( 10 )
      CALL GoToXY ( 1, 8 ) 
      Write ( DemoUnit, 30 )
      CALL GoToXY ( 1, 12 )
      CALL PutChar ( 'A', 1 )
      CALL GoToXY ( 10, 12 )
      Write ( DemoUnit, 40 )
      CALL GoToXY ( 1, 15 )
      CALL PutChar ( 'A', 8 )
      CALL GoToXY ( 10, 15 )
      Write ( DemoUnit, 50 )
      CALL GoToXY ( 1, 18 ) 
      CALL Wait ( 10 )
      Write ( DemoUnit, 60 )
      CALL GoToXY ( 1, 21 )
      CALL PutChattr ( 'A', AttrPaper1, AttrInk1, 2 )
      CALL GoToXY ( 3, 21 )
      CALL PutChattr ( 'A', AttrPaper2, AttrInk2, 3 )
      CALL GoToXY ( 6, 21 )
      CALL PutChattr ( 'A', AttrPaper3, AttrInk3, 2 )
      CALL GoToXY ( 1, 24 )
      Write ( DemoUnit, 70 )
      CALL WaitForKey
10    FORMAT ( '&This is a demonstration screen'/
     +         ' ---- -- - ------------- ------' )
20    FORMAT ( '&As you can see, text can be output to the screen '/
     +         '&in a straightforward manner,'/' using the default '/
     +         '&attributes ( in this case, white ink on black paper'/
     +         '& ) . ' )
30    FORMAT ( '&Individual characters can also be output using '/
     +         '&PutChar and PutChattr.'/' PutChar allows a certain'/
     +         '& character to be output a number of times : ' )
40    FORMAT ( '&A output once, or' )
50    FORMAT ( '&A output with rep = 8' )
60    FORMAT ( '&PutChattr allows individual character attributes '/
     +         '&to be changed. Eg. ' )
70    FORMAT ( '&Press any key to continue' )
      END

******End of subroutine DemoFirstScreen

      SUBROUTINE DemoSecondScreen

******This screen demonstrates how to copy a line using CharXY
******and AttrXY.

      INCLUDE 'F77PC'
      INCLUDE 'TEXTCOM'

      CHARACTER*1 TempChar
      INTEGER Count

      CALL ClrScr
      Write ( DemoUnit, 10 )
      CALL GoToXY ( 1, 5 )
      Write ( DemoUnit, 20 )
      DO 1 Count = 1, 42
	  CALL GoToXY ( Count, 5 )
	  TempChar = CharXY ( )
	  CALL GoToXY ( Count, 7 )
	  CALL PutChattr ( TempChar, AttrPaper1, AttrInk1, 1 )
1     CONTINUE
      CALL GoToXY ( 1, 10 ) 
      Write ( DemoUnit, 30 )
      CALL GoToXY ( 1, 13 )
      Write ( DemoUnit, 40 )
      CALL WaitForKey
10    FORMAT ( '&This is demonstration screen two'/
     +         ' ---- -- ------------- ------ ---' )
20    FORMAT ( '&You can copy lines using CharXY and AttrXY :' )
30    FORMAT ( '&It is also possible to change the attributes '/
     +         '&of the whole screen' )
40    FORMAT ( '&Press any key to continue' )
      END

******End of subroutine DemoSecondScreen

      SUBROUTINE DemoThirdScreen

******This screen demonstrates how screen attribute change works.

      INCLUDE 'TEXTCOM'

      CALL Paper ( AttrPaper2 )
      CALL Ink ( AttrInk2 )
      CALL ClrScr
      Write ( DemoUnit, 10 )
      CALL GoToXY ( 1, 5 )
      Write ( DemoUnit, 20 )
      CALL GoToXY ( 1, 8 )
      Write ( DemoUnit, 30 )
      CALL WaitForKey 
10    FORMAT ( '&This is demonstration screen three'/
     +         ' ---- -- ------------- ------ -----' )
20    FORMAT ( '&Paper and ink have now been altered, so now all '/
     +         '&text appears in these colours.'/' Once more it '/
     +         '&is possible to change individual characters '/
     +         '&attributes' )
30    FORMAT ( '&Press any key to continue' )
      END

******End of subroutine DemoThirdScreen

      SUBROUTINE DemoCursor

******This demonstrates the cursor control subroutines

      INCLUDE 'TEXTCOM'

      INTEGER*2 Count 
 
      CALL Paper ( NormalPaper )
      CALL Ink ( NormalInk )
      CALL ClrScr
      Write ( DemoUnit, 10 )
      CALL GoToXY ( 1, 10 )
      Write ( DemoUnit, 20 )
      CALL Wait ( 2 )
      CALL GoToXY ( 1, 1 )
      CALL Wait ( 2 )
      CALL GoToXY ( 1, 11 )
      Write ( DemoUnit, 30 )
      CALL GoToXY ( 40, 12 )
      CALL Wait ( 5 )
      CALL GoToXY ( 1, 14 )
      Write ( DemoUnit, 40 )
      CALL CursorOff
      CALL Wait ( 5 )
      CALL CursorOn
      Write ( DemoUnit, 50 )
      DO 1 Count = 1, MaxCursor-1
	  CALL CursorShape ( Count, MaxCursor )
	  CALL Wait ( 1 )
1     CONTINUE
      CALL GoToXY ( 1, 17 )
      Write ( DemoUnit, 60 )
      CALL WaitForKey
10    FORMAT ( '&Cursor control demonstration'/
     +         ' ------ ------- -------------' )
20    FORMAT ( '&The cursor can be sent anywhere on the screen, '/
     +         '&to the top' )
30    FORMAT ( '&to the middle, etc.' )
40    FORMAT ( '&The cursor can also be switched off....' )
50    FORMAT ( '&.and on.'/' Its shape can also be altered...' )
60    FORMAT ( '&Press any key to continue' )
      END

******End of subroutine DemoCursor

      SUBROUTINE DemoWindows 

******Demonstrates creating windows, scrolling and message writing
******within those windows.

      INCLUDE 'TEXTCOM'

      CALL Paper ( Screen5 )
      CALL ClrScr
      CALL Paper ( WindowPaper1 )
      CALL Ink ( WindowInk1 )
      CALL InitAWindow ( 2, 10, 42, 19, .FALSE. )
      Write ( DemoUnit, 10 )
      CALL GoToXY ( 1, 3 )
      Write ( DemoUnit, 20 )
      CALL Wait ( 15 )
      CALL TextWindow ( 2, 12, 42, 19 )
      CALL ScrollUp ( 1 )
      CALL GoToXY ( 1, 7 )
      Write ( DemoUnit, 30 )
      CALL Wait ( 15 )
      CALL Paper ( WindowPaper2 )
      CALL Ink ( WindowInk2 )
      CALL InitAWindow ( 30, 5, 70, 22, .TRUE. )
      Write ( DemoUnit, 40 )
      CALL GoToXY ( 1, 4 )
      Write ( DemoUnit, 50 )
      CALL Wait ( 10 )
      CALL GoToXY ( 1, 5 )
      CALL DelLine 
      CALL Wait ( 10 )
      Write ( DemoUnit, 60 )
      CALL Wait ( 5 )
      CALL GoToXY ( 1, 5 )
      CALL InsLine 
      CALL GoToXY ( 1, 9 )
      CALL Wait ( 5 )
      Write ( DemoUnit, 70 )
      CALL GoToXY ( 1, 15 )
      Write ( DemoUnit, 80 )
      CALL WaitForKey
10    FORMAT ( '&This is a demonstration window'/
     +         ' ---- -- - ------------- ------' )
20    FORMAT ( '&Windows can be created, for text, using'/
     +         ' TextWindow. They are specified by top-'/
     +         ' left and bottom-right coordinates. When'/
     +         ' a window has been created, all moving'/
     +         ' is then done relative to that window'/
     +         ' When you reach the bottom, though'/
     +         ' you run out of space and then.....' )
30    FORMAT ( '&you need to scroll the screen up!!' )
40    FORMAT ( '&This is another demonstration window'/
     +         ' ---- -- ------- ------------- ------' )
50    FORMAT ( '&In addition to all described so far, '/
     +         ' you can also delete lines.....' )
60    FORMAT ( '&or you can insert lines....' )
70    FORMAT ( '&Altogether, the F77PC library gives '/
     +         ' some very useful and powerful extra '/
     +         ' text tools. It also gives graphics, '/
     +         ' tools ( CGA, EGA and Turtle ), and '/
     +         ' text editing facilities.' )
80    FORMAT ( '&Press any key to finish the demonstration' )
      END

******End of subroutine DemoWindows
******End of FText demonstration program.
