      PROGRAM Turtle

******This program demonstrates the turtle graphics portions of the
******PAS-PC library by allowing the user to move the 'turtle' by
******using cursor control keys.

******24 February 1989

******Main program unit

      INCLUDE 'TURTCOM'

      CALL DOINIT
      CALL DOTURT
      CALL INITSCREEN
      END

******End of main program unit

      SUBROUTINE DOINIT

******Initialise and check that graphics adaptor is present

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      LOGICAL AdapOK

      CALL INITSCREEN
      SCREEN = 20
      CALL SCREENUNIT (SCREEN)
      Finish = .FALSE.
      Step = 0
      AdapOK = .NOT. ( ( ADAPTOR ( ) .EQ. AdapUnknown )
     +         .OR.  ( ADAPTOR ( ) .EQ. MonoAdap ) )
      IF  ( .NOT. ( AdapOK ) ) THEN
	  CALL FINERR
      ELSE
	  CALL SETRES ( 0 )
      ENDIF
      END

******End of subroutine DoInit

      SUBROUTINE FINERR

******No graphics adaptor - output message and finish

      INCLUDE 'TURTCOM'
      INCLUDE 'F77PC'

      WRITE ( Screen, 10 )
      Finish = .TRUE.
70    IF ( .NOT. ( KEYPRESSED ( ) ) ) GOTO 70
10    FORMAT ( '+Graphics adaptor needed to run this program'/' '/
     +         ' Press any key to finish demonstration' )
      END

******End of subroutine FinErr

      SUBROUTINE SETRES ( Res )

******Set up the turtle window, output list of commands and place
******the turtle in its home position

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      IF (Adaptor() .EQ. 2) THEN
	  IF ( Res .EQ. 0 ) THEN
	      CALL SETSCREENMODE ( CGAGraph )
	      MveNum = 1
	      CALL DOSCR ( 160, 112, 24, 4, 1 )
	  ELSE
	      CALL SETSCREENMODE ( CGAHiRes )
	      CALL CGACOLOUR ( 14 )
	      MveNum = 2
	      CALL DOSCR ( 320, 112, 18, 4, 1 )
	  ENDIF
      ELSE IF (Adaptor() .EQ. 3) THEN
	  CALL SETSCREENMODE ( EGAGRAPH )
	  MveNum = 2
	  CALL DOSCR ( 320, 175, 24, 16, 7 )
      ELSE IF (Adaptor() .EQ. 4) THEN
	  CALL SETSCREENMODE ( VCGraph )
	  MveNum = 2
	  CALL DOSCR ( 320, 240, 36, 16, 7 )
      ELSE IF (Adaptor() .EQ. 5) THEN
	  CALL SETSCREENMODE ( HercGraph )
	  MveNum = 2
	  CALL DOSCR ( 360, 174, 24, 2, 1 )
      ENDIF
      END

******End of subroutine SetRes

      SUBROUTINE DOSCR ( X1, Y1, Top, TotalColours, Colour )

******Draw the turtle window border and output command list
      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      INTEGER X1, Y1, Top, TotalColours, Colour

      CALL MESSGE
      CALL GRAPHWINDOW ( 0, Top, X1*2, Y1*2 )
      CALL GRAPHFRAME  ( Colour )
      CALL TURTLEHOME
      PColor = Colour
      CALL SETPENCOLOR ( Colour )
      TotalCol = TotalColours
      CALL CLIPON
      APenUp = .FALSE.
      CALL PENDOWN
      END

******End of subroutine DoScreen

      SUBROUTINE MESSGE

      INCLUDE 'TURTCOM'

******Output the command list

      INTEGER*1 SCREENMODE, ScrMde

      ScrMde = SCREENMODE ( )
      IF ( ScrMde .GE. 6 ) THEN
	  Write ( Screen, 20 )
      ELSE
	  Write ( Screen, 30 )
      ENDIF
20    FORMAT ( '+Options : (c)olour, (h) / (m) resolution, (r)ight or (l
     +)eft, 0..9 StepLength'/' (p)en up or down. Use Cursor controls
     + and INS to move. ESC to finish' )
30    FORMAT ( '+Options : (c)olour, (h) / (m) resolution'/
     +         '+0..9 Step-Len, (p)en toggle, (r)t & (l)t'/
     +         '+Cursor keys & INS to move. ESC to finish' )
      END

******End of subroutine Messge

      SUBROUTINE DOTURT

******The main program loop

      INCLUDE 'TURTCOM'

60    IF ( Finish ) THEN
      ELSE
	  CALL Next
	  GOTO 60
      ENDIF
      END

******End of subroutine DoTurt

      SUBROUTINE NEXT

******Wait for a key to be pressed, check for ESC and then route to
******either SELECT or ESCSEL

      INCLUDE 'TURTCOM'
      INCLUDE 'F77PC'

      CHARACTER*1 Ch
      INTEGER*2 Scan

40    IF ( .NOT. KEYPRESSED ( ) ) GOTO 40
      IF ( .NOT. ESCAPEKEY ( ) ) THEN
	  CALL GETKEYBOARD ( Ch, Scan )
	  IF ( Ch .EQ. CHAR ( 0 ) ) THEN
	      CALL ESCSEL ( Scan )
	  ELSE
	      CALL SELECT ( Ch )
	  ENDIF
      ELSE
	  Finish = .TRUE.
      ENDIF
      END

******End of subroutine Next

      SUBROUTINE ESCSEL ( Scan )

******Decide which cursor key has been pressed and take appropriate
******action

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      INTEGER*2 Scan

      IF ( Scan .EQ. 72 ) THEN
	  CALL DOMOVE ( North )
      ELSE IF ( Scan .EQ. 77 ) THEN
	  CALL DOMOVE ( East )
      ELSE IF ( Scan .EQ. 80 ) THEN
	  CALL DOMOVE ( South )
      ELSE IF ( Scan .EQ. 75 ) THEN
	  CALL DOMOVE ( West )
      ELSE IF ( Scan .EQ. 73 ) THEN
	  CALL DOMOVE ( NorthE )
      ELSE IF ( Scan .EQ. 81 ) THEN
	  CALL DOMOVE ( SouthE )
      ELSE IF ( Scan .EQ. 71 ) THEN
	  CALL DOMOVE ( NorthW )
      ELSE IF ( Scan .EQ. 79 ) THEN
	  CALL DOMOVE ( SouthW )
      ELSE IF ( Scan .EQ. 82 ) THEN
	  CALL DOMOVE ( Heading ( ) )
      ENDIF
      END

******End of subroutine EscSel

      SUBROUTINE SELECT ( Ch )

******Decide which command has been entered and take appropriate
******action

      CHARACTER*1 Ch

      IF ( ( Ch .EQ. '+' ) .OR. ( Ch .EQ. '=' ) ) THEN
	  CALL TURTHM
      ELSE IF ( ( Ch .EQ. 'P' ) .OR. ( Ch .EQ. 'p' ) ) THEN
	  CALL PENTOG
      ELSE IF ( ( Ch .EQ. 'M' ) .OR. ( Ch .EQ. 'm' ) ) THEN
	  CALL SETRES ( 0 )
      ELSE IF ( ( Ch .EQ. 'H' ) .OR. ( Ch .EQ. 'h' ) ) THEN
	  CALL SETRES ( 1 )
      ELSE IF ( ( Ch .EQ. 'C' ) .OR. ( Ch .EQ. 'c' ) ) THEN
	  CALL PENCOL
      ELSE IF ( ( Ch .EQ. 'R' ) .OR. ( Ch .EQ. 'r' ) ) THEN
	  CALL DOTURN ( 0 )
      ELSE IF ( ( Ch .EQ. 'L' ) .OR. ( Ch .EQ. 'l' ) ) THEN
	  CALL DOTURN ( 1 )
      ELSE IF ( ( Ch .GE. '0' ) .AND. ( Ch .LE. '9' ) ) THEN
	  CALL CHSTEP ( Ch )
      ENDIF
      END

******End of subroutine Select

      SUBROUTINE DOMOVE ( Headng )

******Move turtle by one space in direction required

      INCLUDE 'TURTCOM'

      INTEGER*2 Headng, AMvNum

      CALL CALCMV ( HEADING ( ), AMvNum )
      IF ( APenUp ) THEN
	  CALL XORON
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  CALL FORWD ( AMvNum )
	  CALL XOROFF
	  CALL PENUP
      ENDIF
      CALL SETHEADING ( Headng )
      CALL CALCMV ( Headng, AMvNum )
      IF ( APenUp ) THEN
	  CALL XORON
	  CALL PENDOWN
	  CALL FORWD ( AMvNum )
	  CALL XOROFF
	  CALL PENUP
      ELSE
	  CALL FORWD ( AMvNum )
      ENDIF
      END

******End of subroutine DoMove

      SUBROUTINE TURTHM

******Moves turtle back to its home position

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      INTEGER*2 Headng, AMvNum

      Headng = HEADING ( )
      CALL CALCMV ( Headng, AMvNum )
      CALL XORON
      IF ( APenUp ) THEN
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  CALL FORWD ( AMvNum )
	  CALL PENUP
      ELSE
	  CALL PENUP
	  APenUp = .TRUE.
      ENDIF
      CALL XOROFF
      CALL TURTLEHOME
      CALL FORWD ( AMvNum )
      CALL PENTOG
      END

******End of subroutine TurtHm

      SUBROUTINE PENTOG

******If pen is up then put it down and vice-versa

      INCLUDE 'TURTCOM'

      IF ( APenUp ) THEN
	  CALL PENDOWN
      ELSE
	  CALL PENUP
      ENDIF
      APenUp = ( .NOT. APenUp )
      END

******End of subroutine PenTog

      SUBROUTINE PENCOL

******Alter the pen colour ( only two possible in Hi-Res mode )

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      INTEGER*2 AMvNum, Headng

      Headng = HEADING ( )
      CALL CALCMV ( Headng, AMvNum )
      PColor = PColor + 1
      IF ( PColor .GE. TotalCol ) THEN
	  PColor = 0
      ENDIF
      CALL SETPENCOLOR ( PColor )
      IF ( APenUp ) THEN
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  CALL FORWD ( AMvNum )
	  CALL PENUP
      ENDIF
      END

******End of subroutine PenCol

      SUBROUTINE DOTURN ( RtOrLt )

******Alter current direction by + or - 5 degrees

      INCLUDE 'TURTCOM'
      INCLUDE 'F77PC'

      INTEGER*2 AMvNum, Headng, RtOrLt

      Headng = HEADING ( )
      CALL CALCMV ( Headng, AMvNum )
      IF ( APenUp ) THEN
	  CALL XORON
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  CALL FORWD ( AMvNum )
	  CALL PENUP
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  IF ( RtOrLt .EQ. 0 ) THEN
	      CALL TURNRIGHT ( 5 )
	  ELSE
	      CALL TURNLEFT ( 5 )
	  ENDIF
	  Headng = HEADING ( )
	  CALL CALCMV ( Headng, AMvNum )
	  CALL FORWD ( AMvNum )
	  CALL PENUP
	  CALL XOROFF
      ELSE
	  IF ( RtOrLt .EQ. 0 ) THEN
	      CALL TURNRIGHT ( 5 )
	  ELSE
	      CALL TURNLEFT ( 5 )
	  ENDIF
	  Headng = HEADING ( )
      ENDIF
      END

******End of subroutine DoTurn

      SUBROUTINE ChStep ( Ch )

******Alter the turtle's step length

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      CHARACTER*1 Ch
      INTEGER*2 AMvNum, Headng

      Headng = HEADING ( )
      CALL CALCMV ( Headng, AMvNum )
      IF ( APenUp ) THEN
	  CALL XORON
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  CALL FORWD ( AMvNum )
	  CALL PENUP
	  CALL BACK ( AMvNum )
	  CALL PENDOWN
	  AMvNum = AMvNum - Step
	  Step = ICHAR ( Ch ) - 48
	  AMvNum = AMvNum + Step
	  CALL FORWD ( AMvNum )
	  CALL XOROFF
	  CALL PENUP
      ELSE
	  Step = ICHAR ( Ch ) - 48
      ENDIF
      END

******End of subroutine ChStep

      SUBROUTINE CALCMV ( Headng, AMvNum )

******Calculates the number of pixels to move

      INCLUDE 'F77PC'
      INCLUDE 'TURTCOM'

      INTEGER*2 Headng, AMvNum

      IF ( ( Headng .EQ. 270 ) .OR. ( Headng .EQ. 90 ) ) THEN
	  AMvNum = 1 + Step
      ELSE
	 AMvNum = MveNum + Step
      ENDIF
      END

******End of subroutine CalcMove
******End of the Turtle demonstration program.
